class DelayerM expands Mutator config (DelayedMuts);

var() config string LaterMuts[64];
var() config float DelayLoadTime;
var bool bInit;

event PostBeginPlay()
{
	if ( !bInit )
	{
		bInit=True;
		if ( Caps(string(Outer.Name)) ~= "UT-LOGO-MAP" )
		{
			log ("Mutators/Actors are skipped for this map...",'DelayerM');
		}
		else
		{
			InitialState = 'WaitAndGo';
			if ( DelayLoadTime == 0 )
			{
				Default.DelayLoadTime = 3;
				DelayLoadTime = 3;
				SaveConfig();
			}
		}
	}
	else
	{
		log ("BORK !!!"@Self.Name@"attempt multiple initialization calls.",'DelayerM');
	}
}

final function LoadSetup()
{
	local int i;
	local class<Actor> Act;
	local Actor M;
	local Mutator Mu;

	for (i = 0; i < 64; i++)
	{
		if ( LaterMuts[i] != "" )
		{
			log ("Seeking configured"@LaterMuts[i]$".",'DelayerM');
			Act = class<Actor>(DynamicLoadObject(LaterMuts[i],class'Class'));
			if ( Act != None )
			{
				log ("Found and spawn"@LaterMuts[i]$".",'DelayerM');
				Act.Default.bGameRelevant = True;
				if ( Act.Isa('Mutator') && Level.Game.BaseMutator != None )
				{
					M = Spawn(Act);
					Mu = Mutator(M);
					Level.Game.BaseMutator.AddMutator(Mu);
				}
				else
				{
					Level.Spawn(Act);
				}
			}
			else
			{
				log ("Could not find and load some bullshit called"@LaterMuts[i]$". Have a Nice Day, because... I hate you at random.",'DelayerM');
				break;
			}
			Act = None;
		}
		else
			break;
	}
	log ("Loading Delayed Mutators/Actors has been finished.",'DelayerM');
}

State() WaitAndGo
{
Begin:
	Sleep(DelayLoadTime);
Continuing:
	log (Self.Name@":: Delay Time expired. Proceed to load configured things...",'DelayerM');
	LoadSetup();
	log (Self.Name@":: Loading configured things is being ended...",'DelayerM');
End:
	GoToState('');
}
